searchNodes=[{"ref":"K8s.html","title":"K8s","type":"module","doc":"Documentation for K8s."},{"ref":"K8s.html#http_provider/0","title":"K8s.http_provider/0","type":"function","doc":""},{"ref":"K8s.html#init/0","title":"K8s.init/0","type":"function","doc":"Initialize K8s.Conf and K8s.Group ETS tables"},{"ref":"K8s.Behaviours.DiscoveryProvider.html","title":"K8s.Behaviours.DiscoveryProvider","type":"behaviour","doc":"Kubernetes API Discovery behavior"},{"ref":"K8s.Behaviours.DiscoveryProvider.html#c:resource_definitions_by_group/2","title":"K8s.Behaviours.DiscoveryProvider.resource_definitions_by_group/2","type":"callback","doc":""},{"ref":"K8s.Behaviours.HTTPProvider.html","title":"K8s.Behaviours.HTTPProvider","type":"behaviour","doc":"HTTP Request / Response provider behaviour"},{"ref":"K8s.Behaviours.HTTPProvider.html#c:handle_response/1","title":"K8s.Behaviours.HTTPProvider.handle_response/1","type":"callback","doc":""},{"ref":"K8s.Behaviours.HTTPProvider.html#c:headers/1","title":"K8s.Behaviours.HTTPProvider.headers/1","type":"callback","doc":""},{"ref":"K8s.Behaviours.HTTPProvider.html#c:request/5","title":"K8s.Behaviours.HTTPProvider.request/5","type":"callback","doc":""},{"ref":"K8s.Client.html","title":"K8s.Client","type":"module","doc":"An experimental k8s client. Functions return K8s.Operations that represent kubernetes operations. To run operations pass them to: run/2, run/3, or run/4. When specifying kinds the format should either be in the literal kubernetes kind name (eg &quot;ServiceAccount&quot;) or the downcased version seen in kubectl (eg &quot;serviceaccount&quot;). A string or atom may be used. Examples &quot;Deployment&quot;, &quot;deployment&quot;, :Deployment, :deployment &quot;ServiceAccount&quot;, &quot;serviceaccount&quot;, :ServiceAccount, :serviceaccount &quot;HorizontalPodAutoscaler&quot;, &quot;horizontalpodautoscaler&quot;, :HorizontalPodAutoscaler, :horizontalpodautoscaler opts to K8s.Client.Runner modules are HTTPoison HTTP option overrides."},{"ref":"K8s.Client.html#async/2","title":"K8s.Client.async/2","type":"function","doc":"alias of K8s.Client.Runner.Async.run/3"},{"ref":"K8s.Client.html#async/3","title":"K8s.Client.async/3","type":"function","doc":"alias of K8s.Client.Runner.Async.run/3"},{"ref":"K8s.Client.html#create/1","title":"K8s.Client.create/1","type":"function","doc":"Returns a POST operation to create the given resource. Examples iex&gt; deployment = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, ...&gt; &quot;kind&quot; =&gt; &quot;Deployment&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; }, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;test&quot; ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;replicas&quot; =&gt; 2, ...&gt; &quot;selector&quot; =&gt; %{ ...&gt; &quot;matchLabels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;template&quot; =&gt; %{ ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;containers&quot; =&gt; %{ ...&gt; &quot;image&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; K8s.Client.create(deployment) %K8s.Operation{ method: :post, path_params: [namespace: &quot;test&quot;], verb: :create, group_version: &quot;apps/v1&quot;, kind: &quot;Deployment&quot;, resource: %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; }, &quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;test&quot; }, &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 2, &quot;selector&quot; =&gt; %{ &quot;matchLabels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; %{ &quot;image&quot; =&gt; &quot;nginx&quot;, &quot;name&quot; =&gt; &quot;nginx&quot; } } } } } }"},{"ref":"K8s.Client.html#delete/1","title":"K8s.Client.delete/1","type":"function","doc":"Returns a DELETE operation for a resource by manifest. May be a partial manifest as long as it contains: apiVersion kind metadata.name metadata.namespace (if applicable) K8s Docs: Delete will delete a resource. Depending on the specific resource, child objects may or may not be garbage collected by the server. See notes on specific resource objects for details. Examples iex&gt; deployment = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, ...&gt; &quot;kind&quot; =&gt; &quot;Deployment&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; }, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;test&quot; ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;replicas&quot; =&gt; 2, ...&gt; &quot;selector&quot; =&gt; %{ ...&gt; &quot;matchLabels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;template&quot; =&gt; %{ ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;containers&quot; =&gt; %{ ...&gt; &quot;image&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; K8s.Client.delete(deployment) %K8s.Operation{ method: :delete, verb: :delete, group_version: &quot;apps/v1&quot;, kind: &quot;Deployment&quot;, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;] }"},{"ref":"K8s.Client.html#delete/3","title":"K8s.Client.delete/3","type":"function","doc":"Returns a DELETE operation for a resource by version, kind, name, and optionally namespace. Examples iex&gt; K8s.Client.delete(&quot;apps/v1&quot;, &quot;Deployment&quot;, namespace: &quot;test&quot;, name: &quot;nginx&quot;) %K8s.Operation{ method: :delete, verb: :delete, group_version: &quot;apps/v1&quot;, kind: &quot;Deployment&quot;, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;] }"},{"ref":"K8s.Client.html#delete_all/2","title":"K8s.Client.delete_all/2","type":"function","doc":"Returns a DELETE collection operation for all instances of a cluster scoped resource kind. Examples iex&gt; K8s.Client.delete_all(&quot;extensions/v1beta1&quot;, &quot;PodSecurityPolicy&quot;) %K8s.Operation{ method: :delete, verb: :deletecollection, group_version: &quot;extensions/v1beta1&quot;, kind: &quot;PodSecurityPolicy&quot;, path_params: [] } iex&gt; K8s.Client.delete_all(&quot;storage.k8s.io/v1&quot;, &quot;StorageClass&quot;) %K8s.Operation{ method: :delete, verb: :deletecollection, group_version: &quot;storage.k8s.io/v1&quot;, kind: &quot;StorageClass&quot;, path_params: [] }"},{"ref":"K8s.Client.html#delete_all/3","title":"K8s.Client.delete_all/3","type":"function","doc":"Returns a DELETE collection operation for all instances of a resource kind in a specific namespace. Examples iex&gt; K8s.Client.delete_all(&quot;apps/v1beta1&quot;, &quot;ControllerRevision&quot;, namespace: &quot;default&quot;) %K8s.Operation{ method: :delete, verb: :deletecollection, group_version: &quot;apps/v1beta1&quot;, kind: &quot;ControllerRevision&quot;, path_params: [namespace: &quot;default&quot;] } iex&gt; K8s.Client.delete_all(&quot;apps/v1&quot;, &quot;Deployment&quot;, namespace: &quot;staging&quot;) %K8s.Operation{ method: :delete, verb: :deletecollection, group_version: &quot;apps/v1&quot;, kind: &quot;Deployment&quot;, path_params: [namespace: &quot;staging&quot;] }"},{"ref":"K8s.Client.html#get/1","title":"K8s.Client.get/1","type":"function","doc":"Returns a GET operation for a resource given a manifest. May be a partial manifest as long as it contains: apiVersion kind metadata.name metadata.namespace (if applicable) K8s Docs: Get will retrieve a specific resource object by name. Examples iex&gt; pod = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;v1&quot;, ...&gt; &quot;kind&quot; =&gt; &quot;Pod&quot;, ...&gt; &quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;nginx-pod&quot;, &quot;namespace&quot; =&gt; &quot;test&quot;}, ...&gt; &quot;spec&quot; =&gt; %{&quot;containers&quot; =&gt; %{&quot;image&quot; =&gt; &quot;nginx&quot;}} ...&gt; } ...&gt; K8s.Client.get(pod) %K8s.Operation{ method: :get, verb: :get, group_version: &quot;v1&quot;, kind: &quot;Pod&quot;, path_params: [namespace: &quot;test&quot;, name: &quot;nginx-pod&quot;], }"},{"ref":"K8s.Client.html#get/3","title":"K8s.Client.get/3","type":"function","doc":"Returns a GET operation for a resource by version, kind, name, and optionally namespace. K8s Docs: Get will retrieve a specific resource object by name. Examples iex&gt; K8s.Client.get(&quot;apps/v1&quot;, &quot;Deployment&quot;, namespace: &quot;test&quot;, name: &quot;nginx&quot;) %K8s.Operation{ method: :get, verb: :get, group_version: &quot;apps/v1&quot;, kind: &quot;Deployment&quot;, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;] } iex&gt; K8s.Client.get(&quot;apps/v1&quot;, :deployment, namespace: &quot;test&quot;, name: &quot;nginx&quot;) %K8s.Operation{ method: :get, verb: :get, group_version: &quot;apps/v1&quot;, kind: :deployment, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;]}"},{"ref":"K8s.Client.html#list/3","title":"K8s.Client.list/3","type":"function","doc":"Returns a GET operation to list all resources by version, kind, and namespace. Given the namespace :all as an atom, will perform a list across all namespaces. K8s Docs: List will retrieve all resource objects of a specific type within a namespace, and the results can be restricted to resources matching a selector query. List All Namespaces: Like List but retrieves resources across all namespaces. Examples iex&gt; K8s.Client.list(&quot;v1&quot;, &quot;Pod&quot;, namespace: &quot;default&quot;) %K8s.Operation{ method: :get, verb: :list, group_version: &quot;v1&quot;, kind: &quot;Pod&quot;, path_params: [namespace: &quot;default&quot;] } iex&gt; K8s.Client.list(&quot;apps/v1&quot;, &quot;Deployment&quot;, namespace: :all) %K8s.Operation{ method: :get, verb: :list_all_namespaces, group_version: &quot;apps/v1&quot;, kind: &quot;Deployment&quot;, path_params: [] }"},{"ref":"K8s.Client.html#patch/1","title":"K8s.Client.patch/1","type":"function","doc":"Returns a PATCH operation to patch the given resource. K8s Docs: Patch will apply a change to a specific field. How the change is merged is defined per field. Lists may either be replaced or merged. Merging lists will not preserve ordering. Patches will never cause optimistic locking failures, and the last write will win. Patches are recommended when the full state is not read before an update, or when failing on optimistic locking is undesirable. When patching complex types, arrays and maps, how the patch is applied is defined on a per-field basis and may either replace the field&#39;s current value, or merge the contents into the current value. Examples iex&gt; deployment = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, ...&gt; &quot;kind&quot; =&gt; &quot;Deployment&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; }, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;test&quot; ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;replicas&quot; =&gt; 2, ...&gt; &quot;selector&quot; =&gt; %{ ...&gt; &quot;matchLabels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;template&quot; =&gt; %{ ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;containers&quot; =&gt; %{ ...&gt; &quot;image&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; K8s.Client.patch(deployment) %K8s.Operation{ method: :patch, verb: :patch, group_version: &quot;apps/v1&quot;, kind: &quot;Deployment&quot;, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;], resource: %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; }, &quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;test&quot; }, &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 2, &quot;selector&quot; =&gt; %{ &quot;matchLabels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; %{ &quot;image&quot; =&gt; &quot;nginx&quot;, &quot;name&quot; =&gt; &quot;nginx&quot; } } } } } }"},{"ref":"K8s.Client.html#run/2","title":"K8s.Client.run/2","type":"function","doc":"alias of K8s.Client.Runner.Base.run/2"},{"ref":"K8s.Client.html#run/3","title":"K8s.Client.run/3","type":"function","doc":"alias of K8s.Client.Runner.Base.run/3"},{"ref":"K8s.Client.html#run/4","title":"K8s.Client.run/4","type":"function","doc":"alias of K8s.Client.Runner.Base.run/4"},{"ref":"K8s.Client.html#update/1","title":"K8s.Client.update/1","type":"function","doc":"Returns a PUT operation to replace/update the given resource. K8s Docs: Replacing a resource object will update the resource by replacing the existing spec with the provided one. For read-then-write operations this is safe because an optimistic lock failure will occur if the resource was modified between the read and write. Note: The ResourceStatus will be ignored by the system and will not be updated. To update the status, one must invoke the specific status update operation. Note: Replacing a resource object may not result immediately in changes being propagated to downstream objects. For instance replacing a ConfigMap or Secret resource will not result in all Pods seeing the changes unless the Pods are restarted out of band. Examples iex&gt; deployment = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, ...&gt; &quot;kind&quot; =&gt; &quot;Deployment&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; }, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;test&quot; ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;replicas&quot; =&gt; 2, ...&gt; &quot;selector&quot; =&gt; %{ ...&gt; &quot;matchLabels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;template&quot; =&gt; %{ ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;containers&quot; =&gt; %{ ...&gt; &quot;image&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; K8s.Client.update(deployment) %K8s.Operation{ method: :put, verb: :update, group_version: &quot;apps/v1&quot;, kind: &quot;Deployment&quot;, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;], resource: %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; }, &quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;test&quot; }, &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 2, &quot;selector&quot; =&gt; %{ &quot;matchLabels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; %{ &quot;image&quot; =&gt; &quot;nginx&quot;, &quot;name&quot; =&gt; &quot;nginx&quot; } } } } } }"},{"ref":"K8s.Client.html#wait_until/3","title":"K8s.Client.wait_until/3","type":"function","doc":"alias of K8s.Client.Runner.Wait.run/3"},{"ref":"K8s.Client.html#watch/3","title":"K8s.Client.watch/3","type":"function","doc":"alias of K8s.Client.Runner.Watch.run/3"},{"ref":"K8s.Client.html#watch/4","title":"K8s.Client.watch/4","type":"function","doc":"alias of K8s.Client.Runner.Watch.run/4"},{"ref":"K8s.Client.html#t:option/0","title":"K8s.Client.option/0","type":"type","doc":""},{"ref":"K8s.Client.html#t:options/0","title":"K8s.Client.options/0","type":"type","doc":""},{"ref":"K8s.Client.HTTPProvider.html","title":"K8s.Client.HTTPProvider","type":"module","doc":"HTTPoison and Jason based K8s.Behaviours.HTTPProvider"},{"ref":"K8s.Client.HTTPProvider.html#handle_response/1","title":"K8s.Client.HTTPProvider.handle_response/1","type":"function","doc":"Handle HTTPoison responses and errors Examples Parses successful JSON responses: iex&gt; body = ~s({&quot;foo&quot;: &quot;bar&quot;}) ...&gt; K8s.Client.HTTPProvider.handle_response({:ok, %HTTPoison.Response{status_code: 200, body: body}}) {:ok, %{&quot;foo&quot; =&gt; &quot;bar&quot;}} Handles unauthorized responses: iex&gt; K8s.Client.HTTPProvider.handle_response({:ok, %HTTPoison.Response{status_code: 401}}) {:error, :unauthorized} Handles not found responses: iex&gt; K8s.Client.HTTPProvider.handle_response({:ok, %HTTPoison.Response{status_code: 404}}) {:error, :not_found} Handles 4xx responses: iex&gt; K8s.Client.HTTPProvider.handle_response({:ok, %HTTPoison.Response{status_code: 410, body: &quot;Gone&quot;}}) {:error, &quot;HTTP Error: 410; Gone&quot;} Handles HTTPoison error responses: iex&gt; K8s.Client.HTTPProvider.handle_response({:error, %HTTPoison.Error{reason: &quot;Foo&quot;}}) {:error, &quot;HTTP Client Error: Foo&quot;}"},{"ref":"K8s.Client.HTTPProvider.html#headers/1","title":"K8s.Client.HTTPProvider.headers/1","type":"function","doc":"Appends Accept and Content-Type headers to K8s.Conf.RequestOptions headers. Example iex&gt; ro = %K8s.Conf.RequestOptions{headers: [{&quot;Authorization&quot;, &quot;Basic AF&quot;}]} ...&gt; K8s.Client.HTTPProvider.headers(ro) [{&quot;Authorization&quot;, &quot;Basic AF&quot;},{&quot;Accept&quot;, &quot;application/json&quot;}, {&quot;Content-Type&quot;, &quot;application/json&quot;}]"},{"ref":"K8s.Client.Runner.Async.html","title":"K8s.Client.Runner.Async","type":"module","doc":"K8s.Client runner to process a batch of operations asynchronously."},{"ref":"K8s.Client.Runner.Async.html#run/3","title":"K8s.Client.Runner.Async.run/3","type":"function","doc":"Async run multiple operations. Operations will be returned in same order given. Operations will not cease in event of failure. Example Get a list of pods, then map each one to an individual GET operation: # Get the pods operation = K8s.Client.list(&quot;v1&quot;, &quot;Pod&quot;, namespace: :all) {:ok, %{&quot;items&quot; =&gt; pods}} = K8s.Client.run(operation, &quot;test-cluster&quot;) # Map each one to an individual `GET` operation. operations = Enum.map(pods, fn(%{&quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; name, &quot;namespace&quot; =&gt; ns}}) -&gt; K8s.Client.get(&quot;v1&quot;, &quot;Pod&quot;, namespace: ns, name: name) end) # Get the results asynchronously results = K8s.Client.Async.run(operations, &quot;test-cluster&quot;)"},{"ref":"K8s.Client.Runner.Base.html","title":"K8s.Client.Runner.Base","type":"module","doc":"Base HTTP processor for K8s.Client"},{"ref":"K8s.Client.Runner.Base.html#encode/2","title":"K8s.Client.Runner.Base.encode/2","type":"function","doc":""},{"ref":"K8s.Client.Runner.Base.html#run/2","title":"K8s.Client.Runner.Base.run/2","type":"function","doc":"Runs a K8s.Operation. Examples Note: Examples assume a cluster was registered named &quot;test-cluster&quot;, see K8s.Cluster.register/2. Running a list pods operation: operation = K8s.Client.list(&quot;v1&quot;, &quot;Pod&quot;, namespace: :all) {:ok, %{&quot;items&quot; =&gt; pods}} = K8s.Client.run(operation, &quot;test-cluster&quot;) Running a dry-run of a create deployment operation: deployment = %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; }, &quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;test&quot; }, &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 2, &quot;selector&quot; =&gt; %{ &quot;matchLabels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; %{ &quot;image&quot; =&gt; &quot;nginx&quot;, &quot;name&quot; =&gt; &quot;nginx&quot; } } } } } operation = K8s.Client.create(deployment) # opts is passed to HTTPoison as opts. opts = [params: %{&quot;dryRun&quot; =&gt; &quot;all&quot;}] :ok = K8s.Client.Runner.Base.run(operation, &quot;test-cluster&quot;, opts)"},{"ref":"K8s.Client.Runner.Base.html#run/3","title":"K8s.Client.Runner.Base.run/3","type":"function","doc":"Run an operation and pass opts to HTTPoison. See run/2"},{"ref":"K8s.Client.Runner.Base.html#run/4","title":"K8s.Client.Runner.Base.run/4","type":"function","doc":"Run an operation with an alternative HTTP Body (map) and pass opts to HTTPoison. See run/2"},{"ref":"K8s.Client.Runner.Base.html#t:result/0","title":"K8s.Client.Runner.Base.result/0","type":"type","doc":""},{"ref":"K8s.Client.Runner.Wait.html","title":"K8s.Client.Runner.Wait","type":"module","doc":"Waiting functionality for K8s.Client. Note: This is built using repeated GET operations rather than using a watch operation w/ fieldSelector."},{"ref":"K8s.Client.Runner.Wait.html#run/3","title":"K8s.Client.Runner.Wait.run/3","type":"function","doc":"Continually perform a GET based operation until a condition is met. Example Checking the number of job completions: op = K8s.Client.get(&quot;batch/v1&quot;, :job, namespace: &quot;default&quot;, name: &quot;sleep&quot;) opts = [find: [&quot;status&quot;, &quot;succeeded&quot;], eval: 1, timeout: 60] resp = K8s.Client.Runner.Wait.run(op, cluster_name, opts)"},{"ref":"K8s.Client.Runner.Wait.html#t:t/0","title":"K8s.Client.Runner.Wait.t/0","type":"type","doc":"A wait configuration"},{"ref":"K8s.Client.Runner.Watch.html","title":"K8s.Client.Runner.Watch","type":"module","doc":"K8s.Client runner that will watch a resource or resources and stream results back to a process."},{"ref":"K8s.Client.Runner.Watch.html#run/3","title":"K8s.Client.Runner.Watch.run/3","type":"function","doc":"Watch a resource or list of resources. Provide the stream_to option or results will be stream to self(). Note: Current resource version will be looked up automatically. Examples operation = K8s.Client.list(&quot;v1&quot;, &quot;Namespace&quot;) {:ok, reference} = Watch.run(operation, :test, stream_to: self()) operation = K8s.Client.get(&quot;v1&quot;, &quot;Namespace&quot;, [name: &quot;test&quot;]) {:ok, reference} = Watch.run(operation, :test, stream_to: self())"},{"ref":"K8s.Client.Runner.Watch.html#run/4","title":"K8s.Client.Runner.Watch.run/4","type":"function","doc":"Watch a resource or list of resources from a specific resource version. Provide the stream_to option or results will be stream to self(). Examples operation = K8s.Client.list(&quot;v1&quot;, &quot;Namespace&quot;) resource_version = 3003 {:ok, reference} = Watch.run(operation, :test, resource_version, stream_to: self()) operation = K8s.Client.get(&quot;v1&quot;, &quot;Namespace&quot;, [name: &quot;test&quot;]) resource_version = 3003 {:ok, reference} = Watch.run(operation, :test, resource_version, stream_to: self())"},{"ref":"K8s.Cluster.html","title":"K8s.Cluster","type":"module","doc":"Cluster configuration and API route store for K8s.Client"},{"ref":"K8s.Cluster.html#conf/1","title":"K8s.Cluster.conf/1","type":"function","doc":"Retrieve a cluster&#39;s connection configuration. Example iex&gt; config_file = K8s.Conf.from_file(&quot;./test/support/kube-config.yaml&quot;) ...&gt; K8s.Cluster.register(&quot;test-cluster&quot;, config_file) ...&gt; {:ok, conf} = K8s.Cluster.conf(&quot;test-cluster&quot;) ...&gt; conf #Conf&lt;%{cluster: &quot;docker-for-desktop-cluster&quot;, user: &quot;docker-for-desktop&quot;}&gt;"},{"ref":"K8s.Cluster.html#list/0","title":"K8s.Cluster.list/0","type":"function","doc":"List registered cluster names"},{"ref":"K8s.Cluster.html#register/2","title":"K8s.Cluster.register/2","type":"function","doc":"Register a new cluster to use with K8s.Client Examples iex&gt; conf = K8s.Conf.from_file(&quot;./test/support/kube-config.yaml&quot;) ...&gt; &quot;test-cluster&quot; = K8s.Cluster.register(&quot;test-cluster&quot;, conf) &quot;test-cluster&quot;"},{"ref":"K8s.Cluster.html#register_clusters/0","title":"K8s.Cluster.register_clusters/0","type":"function","doc":"Registers clusters automatically from config.exs Examples By default a cluster will attempt to use the ServiceAccount assigned to the pod: config :k8s, clusters: %{ default: %{} } Configuring a cluster using a k8s config: config :k8s, clusters: %{ default: %{ conf: &quot;~/.kube/config&quot; conf_opts: [user: &quot;some-user&quot;, cluster: &quot;prod-cluster&quot;] } }"},{"ref":"K8s.Cluster.html#url_for/2","title":"K8s.Cluster.url_for/2","type":"function","doc":"Retrieve the URL for a K8s.Operation Examples iex&gt; conf = K8s.Conf.from_file(&quot;./test/support/kube-config.yaml&quot;) ...&gt; K8s.Cluster.register(&quot;test-cluster&quot;, conf) ...&gt; operation = K8s.Operation.build(:get, &quot;apps/v1&quot;, :deployment, [namespace: &quot;default&quot;, name: &quot;nginx&quot;]) ...&gt; K8s.Cluster.url_for(operation, &quot;test-cluster&quot;) {:ok, &quot;https://localhost:6443/apis/apps/v1/namespaces/default/deployments/nginx&quot;}"},{"ref":"K8s.Conf.html","title":"K8s.Conf","type":"module","doc":"Handles connection details for a Kubernetes cluster"},{"ref":"K8s.Conf.html#from_file/2","title":"K8s.Conf.from_file/2","type":"function","doc":"Reads configuration details from a kubernetes config file. Defaults to current-context. Options context sets an alternate context cluster set or override the cluster read from the context user set or override the user read from the context"},{"ref":"K8s.Conf.html#from_service_account/0","title":"K8s.Conf.from_service_account/0","type":"function","doc":"Generates configuration from kubernetes service account Links kubernetes.io :: Accessing the API from a Pod"},{"ref":"K8s.Conf.html#from_service_account/1","title":"K8s.Conf.from_service_account/1","type":"function","doc":""},{"ref":"K8s.Conf.html#t:t/0","title":"K8s.Conf.t/0","type":"type","doc":""},{"ref":"K8s.Conf.Auth.html","title":"K8s.Conf.Auth","type":"behaviour","doc":"Authorization behaviour"},{"ref":"K8s.Conf.Auth.html#c:create/2","title":"K8s.Conf.Auth.create/2","type":"callback","doc":""},{"ref":"K8s.Conf.Auth.Certificate.html","title":"K8s.Conf.Auth.Certificate","type":"module","doc":"Certificate based cluster authentication."},{"ref":"K8s.Conf.Auth.Certificate.html#t:t/0","title":"K8s.Conf.Auth.Certificate.t/0","type":"type","doc":""},{"ref":"K8s.Conf.Auth.Token.html","title":"K8s.Conf.Auth.Token","type":"module","doc":"Token based cluster authentication"},{"ref":"K8s.Conf.Auth.Token.html#t:t/0","title":"K8s.Conf.Auth.Token.t/0","type":"type","doc":""},{"ref":"K8s.Conf.PKI.html","title":"K8s.Conf.PKI","type":"module","doc":"Retrieves information from certificates"},{"ref":"K8s.Conf.PKI.html#cert_from_base64/1","title":"K8s.Conf.PKI.cert_from_base64/1","type":"function","doc":"Decodes the certificate from a base64 encoded string"},{"ref":"K8s.Conf.PKI.html#cert_from_map/2","title":"K8s.Conf.PKI.cert_from_map/2","type":"function","doc":"Reads the certificate from PEM file or base64 encoding"},{"ref":"K8s.Conf.PKI.html#cert_from_pem/1","title":"K8s.Conf.PKI.cert_from_pem/1","type":"function","doc":"Reads the certificate from a PEM file"},{"ref":"K8s.Conf.PKI.html#private_key_from_base64/1","title":"K8s.Conf.PKI.private_key_from_base64/1","type":"function","doc":"Decodes private key from a base64 encoded string"},{"ref":"K8s.Conf.PKI.html#private_key_from_pem/1","title":"K8s.Conf.PKI.private_key_from_pem/1","type":"function","doc":"Reads private key from a PEM file"},{"ref":"K8s.Conf.RequestOptions.html","title":"K8s.Conf.RequestOptions","type":"protocol","doc":"Encapsulates HTTP request options for an authentication provider."},{"ref":"K8s.Conf.RequestOptions.html#generate/1","title":"K8s.Conf.RequestOptions.generate/1","type":"function","doc":""},{"ref":"K8s.Conf.RequestOptions.html#t:t/0","title":"K8s.Conf.RequestOptions.t/0","type":"type","doc":"HTTP Request options"},{"ref":"K8s.Discovery.html","title":"K8s.Discovery","type":"module","doc":"Auto discovery of Kubenetes API Versions and Groups."},{"ref":"K8s.Discovery.html#api_paths/2","title":"K8s.Discovery.api_paths/2","type":"function","doc":"Get a map of API type to groups Examples iex&gt; K8s.Discovery.api_paths(:test) %{&quot;/api&quot; =&gt; [&quot;v1&quot;], &quot;/apis&quot; =&gt; [&quot;apps/v1&quot;, &quot;batch/v1&quot;]}"},{"ref":"K8s.Discovery.html#resource_definitions_by_group/2","title":"K8s.Discovery.resource_definitions_by_group/2","type":"function","doc":"List all resource definitions by group Examples iex&gt; K8s.Discovery.resource_definitions_by_group(:test) [%{&quot;apiVersion&quot; =&gt; &quot;v1&quot;, &quot;groupVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;APIResourceList&quot;, &quot;resources&quot; =&gt; [%{&quot;kind&quot; =&gt; &quot;DaemonSet&quot;, &quot;name&quot; =&gt; &quot;daemonsets&quot;, &quot;namespaced&quot; =&gt; true, &quot;verbs&quot; =&gt; [&quot;create&quot;, &quot;delete&quot;, &quot;deletecollection&quot;, &quot;get&quot;, &quot;list&quot;, &quot;patch&quot;, &quot;update&quot;, &quot;watch&quot;]}, %{&quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;name&quot; =&gt; &quot;deployments&quot;, &quot;namespaced&quot; =&gt; true, &quot;verbs&quot; =&gt; [&quot;create&quot;, &quot;delete&quot;, &quot;deletecollection&quot;, &quot;get&quot;, &quot;list&quot;, &quot;patch&quot;, &quot;update&quot;, &quot;watch&quot;]}]}, %{&quot;apiVersion&quot; =&gt; &quot;v1&quot;, &quot;groupVersion&quot; =&gt; &quot;batch/v1&quot;, &quot;kind&quot; =&gt; &quot;APIResourceList&quot;, &quot;resources&quot; =&gt; [%{&quot;kind&quot; =&gt; &quot;Job&quot;, &quot;name&quot; =&gt; &quot;jobs&quot;, &quot;namespaced&quot; =&gt; true, &quot;verbs&quot; =&gt; [&quot;create&quot;, &quot;delete&quot;, &quot;deletecollection&quot;, &quot;get&quot;, &quot;list&quot;, &quot;patch&quot;, &quot;update&quot;, &quot;watch&quot;]}]}, %{&quot;groupVersion&quot; =&gt; &quot;v1&quot;, &quot;kind&quot; =&gt; &quot;APIResourceList&quot;, &quot;resources&quot; =&gt; [%{&quot;kind&quot; =&gt; &quot;Namespace&quot;, &quot;name&quot; =&gt; &quot;namespaces&quot;, &quot;namespaced&quot; =&gt; false, &quot;verbs&quot; =&gt; [&quot;create&quot;, &quot;delete&quot;, &quot;get&quot;, &quot;list&quot;, &quot;patch&quot;, &quot;update&quot;, &quot;watch&quot;]}]}]"},{"ref":"K8s.Group.html","title":"K8s.Group","type":"module","doc":"Kubernetes API Groups"},{"ref":"K8s.Group.html#cluster_key/2","title":"K8s.Group.cluster_key/2","type":"function","doc":"Creates a ETS key for K8s.Group per K8s.Cluster Examples iex. K8s.Group.cluster_key(:dev, &quot;apps/v1&quot;) &quot;dev/apps/v1&quot;"},{"ref":"K8s.Group.html#find_resource/3","title":"K8s.Group.find_resource/3","type":"function","doc":"Finds a resource definition by group version and kind"},{"ref":"K8s.Operation.html","title":"K8s.Operation","type":"module","doc":"Encapsulates a k8s swagger operations"},{"ref":"K8s.Operation.html#build/2","title":"K8s.Operation.build/2","type":"function","doc":"Builds an Operation given an verb and a k8s resource. Examples iex&gt; deploy = %{&quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{&quot;namespace&quot; =&gt; &quot;default&quot;, &quot;name&quot; =&gt; &quot;nginx&quot;}} ...&gt; K8s.Operation.build(:put, deploy) %K8s.Operation{ method: :put, verb: :put, resource: %{&quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{&quot;namespace&quot; =&gt; &quot;default&quot;, &quot;name&quot; =&gt; &quot;nginx&quot;}}, path_params: [namespace: &quot;default&quot;, name: &quot;nginx&quot;], group_version: &quot;apps/v1&quot;, kind: &quot;Deployment&quot; }"},{"ref":"K8s.Operation.html#build/5","title":"K8s.Operation.build/5","type":"function","doc":"Builds an Operation given an verb and a k8s resource info Examples iex&gt; K8s.Operation.build(:get, &quot;apps/v1&quot;, :deployment, [namespace: &quot;default&quot;, name: &quot;nginx&quot;]) %K8s.Operation{ method: :get, verb: :get, resource: nil, path_params: [namespace: &quot;default&quot;, name: &quot;nginx&quot;], group_version: &quot;apps/v1&quot;, kind: :deployment }"},{"ref":"K8s.Operation.html#t:t/0","title":"K8s.Operation.t/0","type":"type","doc":""},{"ref":"K8s.Path.html","title":"K8s.Path","type":"module","doc":"Generates Kubernetes REST API Paths"},{"ref":"K8s.Path.html#build/4","title":"K8s.Path.build/4","type":"function","doc":"Generates the API path for a given group/version and resource. Examples Generate a path for a cluster scoped resource: iex&gt; resource = %{ ...&gt; &quot;kind&quot; =&gt; &quot;CertificateSigningRequest&quot;, ...&gt; &quot;name&quot; =&gt; &quot;certificatesigningrequests&quot;, ...&gt; &quot;namespaced&quot; =&gt; false, ...&gt; &quot;verbs&quot; =&gt; [&quot;update&quot;] ...&gt; } ...&gt; K8s.Path.build(&quot;apps/v1&quot;, resource, :update, [name: &quot;foo&quot;]) {:ok, &quot;/apis/apps/v1/certificatesigningrequests/foo&quot;} Generate a path for a namespace scoped resource: iex&gt; resource = %{ ...&gt; &quot;kind&quot; =&gt; &quot;Pod&quot;, ...&gt; &quot;name&quot; =&gt; &quot;pods&quot;, ...&gt; &quot;namespaced&quot; =&gt; true, ...&gt; &quot;verbs&quot; =&gt; [&quot;update&quot;] ...&gt; } ...&gt; K8s.Path.build(&quot;v1&quot;, resource, :update, [namespace: &quot;default&quot;, name: &quot;foo&quot;]) {:ok, &quot;/api/v1/namespaces/default/pods/foo&quot;} Generate a path for a namespace scoped resource on the collection: (ie create, list) iex&gt; resource = %{ ...&gt; &quot;kind&quot; =&gt; &quot;Pod&quot;, ...&gt; &quot;name&quot; =&gt; &quot;pods&quot;, ...&gt; &quot;namespaced&quot; =&gt; true, ...&gt; &quot;verbs&quot; =&gt; [&quot;create&quot;] ...&gt; } ...&gt; K8s.Path.build(&quot;v1&quot;, resource, :create, [namespace: &quot;default&quot;]) {:ok, &quot;/api/v1/namespaces/default/pods&quot;} Generating a listing path for a namespace: iex&gt; resource = %{ ...&gt; &quot;kind&quot; =&gt; &quot;Pod&quot;, ...&gt; &quot;name&quot; =&gt; &quot;pods&quot;, ...&gt; &quot;namespaced&quot; =&gt; true, ...&gt; &quot;verbs&quot; =&gt; [&quot;list&quot;] ...&gt; } ...&gt; K8s.Path.build(&quot;v1&quot;, resource, :list, [namespace: &quot;default&quot;]) {:ok, &quot;/api/v1/namespaces/default/pods&quot;} Generating a listing path for a all namespaces: iex&gt; resource = %{ ...&gt; &quot;kind&quot; =&gt; &quot;Pod&quot;, ...&gt; &quot;name&quot; =&gt; &quot;pods&quot;, ...&gt; &quot;namespaced&quot; =&gt; true, ...&gt; &quot;verbs&quot; =&gt; [&quot;list&quot;] ...&gt; } ...&gt; K8s.Path.build(&quot;v1&quot;, resource, :list_all_namespaces, []) {:ok, &quot;/api/v1/pods&quot;} Generating a path for a subresource: iex&gt; resource = %{ ...&gt; &quot;kind&quot; =&gt; &quot;Pod&quot;, ...&gt; &quot;name&quot; =&gt; &quot;pods/status&quot;, ...&gt; &quot;namespaced&quot; =&gt; true, ...&gt; &quot;verbs&quot; =&gt; [&quot;get&quot;] ...&gt; } ...&gt; K8s.Path.build(&quot;v1&quot;, resource, :get, [namespace: &quot;default&quot;, name: &quot;foo&quot;]) {:ok, &quot;/api/v1/namespaces/default/pods/foo/status&quot;} Deleting a collection: iex&gt; resource = %{ ...&gt; &quot;kind&quot; =&gt; &quot;Pod&quot;, ...&gt; &quot;name&quot; =&gt; &quot;pods&quot;, ...&gt; &quot;namespaced&quot; =&gt; true, ...&gt; &quot;verbs&quot; =&gt; [ ...&gt; &quot;deletecollection&quot; ...&gt; ] ...&gt; } ...&gt; K8s.Path.build(&quot;v1&quot;, resource, :deletecollection, [namespace: &quot;default&quot;]) {:ok, &quot;/api/v1/namespaces/default/pods&quot;}"},{"ref":"K8s.Path.html#find_params/1","title":"K8s.Path.find_params/1","type":"function","doc":"Find valid path params in a URL path. Examples iex&gt; K8s.Path.find_params(&quot;/foo/{name}&quot;) [:name] iex&gt; K8s.Path.find_params(&quot;/foo/{namespace}/bar/{name}&quot;) [:namespace, :name] iex&gt; K8s.Path.find_params(&quot;/foo/bar&quot;) []"},{"ref":"K8s.Path.html#replace_path_vars/2","title":"K8s.Path.replace_path_vars/2","type":"function","doc":"Replaces path variables with options. Examples iex&gt; K8s.Path.replace_path_vars(&quot;/foo/{name}&quot;, name: &quot;bar&quot;) &quot;/foo/bar&quot;"},{"ref":"K8s.Resource.html","title":"K8s.Resource","type":"module","doc":"Manifest attribute helpers"},{"ref":"K8s.Resource.html#all_from_file!/2","title":"K8s.Resource.all_from_file!/2","type":"function","doc":"Create a list of resource Maps from a YAML file with multi object annotation. Raises File.Error when the file does not exist. Examples iex&gt; opts = [namespace: &quot;default&quot;, name: &quot;nginx&quot;, image: &quot;nginx:nginx:1.7.9&quot;] ...&gt; K8s.Resource.all_from_file!(&quot;test/support/helm-chart.yaml&quot;, opts) [ %{ &quot;apiVersion&quot; =&gt; &quot;v1&quot;, &quot;kind&quot; =&gt; &quot;Namespace&quot;, &quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;default&quot;} }, %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}, &quot;name&quot; =&gt; &quot;nginx-deployment&quot;, &quot;namespace&quot; =&gt; &quot;default&quot; }, &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 3, &quot;selector&quot; =&gt; %{&quot;matchLabels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}}, &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}}, &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; [ %{ &quot;image&quot; =&gt; &quot;nginx:nginx:1.7.9&quot;, &quot;name&quot; =&gt; &quot;nginx&quot;, &quot;ports&quot; =&gt; [%{&quot;containerPort&quot; =&gt; 80}] } ] } } } } ]"},{"ref":"K8s.Resource.html#annotation/2","title":"K8s.Resource.annotation/2","type":"function","doc":"Returns the value of a k8s resource&#39;s annotation. Examples iex&gt; K8s.Resource.annotation(%{&quot;metadata&quot; =&gt; %{&quot;annotations&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}, &quot;env&quot;) &quot;test&quot;"},{"ref":"K8s.Resource.html#annotations/1","title":"K8s.Resource.annotations/1","type":"function","doc":"Returns the annotations of k8s resource. Examples iex&gt; K8s.Resource.annotations(%{&quot;metadata&quot; =&gt; %{&quot;annotations&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}) %{&quot;env&quot; =&gt; &quot;test&quot;}"},{"ref":"K8s.Resource.html#from_file!/2","title":"K8s.Resource.from_file!/2","type":"function","doc":"Create a resource Map from a YAML file. Raises File.Error when the file does not exist. Examples iex&gt; opts = [namespace: &quot;default&quot;, name: &quot;nginx&quot;, image: &quot;nginx:nginx:1.7.9&quot;] ...&gt; K8s.Resource.from_file!(&quot;test/support/deployment.yaml&quot;, opts) %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}, &quot;name&quot; =&gt; &quot;nginx-deployment&quot;, &quot;namespace&quot; =&gt; &quot;default&quot; }, &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 3, &quot;selector&quot; =&gt; %{&quot;matchLabels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}}, &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}}, &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; [ %{ &quot;image&quot; =&gt; &quot;nginx:nginx:1.7.9&quot;, &quot;name&quot; =&gt; &quot;nginx&quot;, &quot;ports&quot; =&gt; [%{&quot;containerPort&quot; =&gt; 80}] } ] } } } }"},{"ref":"K8s.Resource.html#has_annotation?/2","title":"K8s.Resource.has_annotation?/2","type":"function","doc":"Check if an annotation is present. Examples iex&gt; K8s.Resource.has_annotation?(%{&quot;metadata&quot; =&gt; %{&quot;annotations&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}, &quot;env&quot;) true iex&gt; K8s.Resource.has_annotation?(%{&quot;metadata&quot; =&gt; %{&quot;annotations&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}, &quot;foo&quot;) false"},{"ref":"K8s.Resource.html#has_label?/2","title":"K8s.Resource.has_label?/2","type":"function","doc":"Check if a label is present. Examples iex&gt; K8s.Resource.has_label?(%{&quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}, &quot;env&quot;) true iex&gt; K8s.Resource.has_label?(%{&quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}, &quot;foo&quot;) false"},{"ref":"K8s.Resource.html#kind/1","title":"K8s.Resource.kind/1","type":"function","doc":"Returns the kind of k8s resource. Examples iex&gt; K8s.Resource.kind(%{&quot;kind&quot; =&gt; &quot;Deployment&quot;}) &quot;Deployment&quot;"},{"ref":"K8s.Resource.html#label/2","title":"K8s.Resource.label/2","type":"function","doc":"Returns the value of a k8s resource&#39;s label. Examples iex&gt; K8s.Resource.label(%{&quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}, &quot;env&quot;) &quot;test&quot;"},{"ref":"K8s.Resource.html#labels/1","title":"K8s.Resource.labels/1","type":"function","doc":"Returns the labels of k8s resource. Examples iex&gt; K8s.Resource.labels(%{&quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}) %{&quot;env&quot; =&gt; &quot;test&quot;}"},{"ref":"K8s.Resource.html#metadata/1","title":"K8s.Resource.metadata/1","type":"function","doc":"Returns the metadata of k8s resource. Examples iex&gt; K8s.Resource.metadata(%{&quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;foo&quot;}}) %{&quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;foo&quot;}"},{"ref":"K8s.Resource.html#name/1","title":"K8s.Resource.name/1","type":"function","doc":"Returns the name of k8s resource. Examples iex&gt; K8s.Resource.name(%{&quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;foo&quot;}}) &quot;nginx&quot;"},{"ref":"K8s.Resource.html#namespace/1","title":"K8s.Resource.namespace/1","type":"function","doc":"Returns the namespace of k8s resource. Examples iex&gt; K8s.Resource.namespace(%{&quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;foo&quot;}}) &quot;foo&quot;"},{"ref":"K8s.Version.html","title":"K8s.Version","type":"module","doc":"Kubernetes API Versioning"},{"ref":"K8s.Version.html#alpha/1","title":"K8s.Version.alpha/1","type":"function","doc":"Returns only alpha versions Examples iex&gt; K8s.Version.alpha([&quot;v1alpha1&quot;, &quot;v1&quot;, &quot;v2beta1&quot;]) [%K8s.Version{major: 1, minor: &quot;alpha&quot;, patch: 1}]"},{"ref":"K8s.Version.html#beta/1","title":"K8s.Version.beta/1","type":"function","doc":"Returns only beta versions Examples iex&gt; K8s.Version.beta([&quot;v1alpha1&quot;, &quot;v1&quot;, &quot;v2beta1&quot;]) [%K8s.Version{major: 2, minor: &quot;beta&quot;, patch: 1}]"},{"ref":"K8s.Version.html#edge/1","title":"K8s.Version.edge/1","type":"function","doc":"Retuns all non-stable versions Examples iex&gt; K8s.Version.edge([&quot;v1alpha1&quot;, &quot;v1&quot;, &quot;v2beta1&quot;]) [%K8s.Version{major: 1, minor: &quot;alpha&quot;, patch: 1}, %K8s.Version{major: 2, minor: &quot;beta&quot;, patch: 1}]"},{"ref":"K8s.Version.html#parse/1","title":"K8s.Version.parse/1","type":"function","doc":"Parses a Kubernetes API version into a K8s.Version struct Examples iex&gt; K8s.Version.parse(&quot;v1&quot;) %K8s.Version{major: 1, minor: &quot;stable&quot;, patch: nil} iex&gt; K8s.Version.parse(&quot;v1beta2&quot;) %K8s.Version{major: 1, minor: &quot;beta&quot;, patch: 2} iex&gt; K8s.Version.parse(&quot;v1alpha1&quot;) %K8s.Version{major: 1, minor: &quot;alpha&quot;, patch: 1}"},{"ref":"K8s.Version.html#recommended/1","title":"K8s.Version.recommended/1","type":"function","doc":"Returns the recommended version from a list of versions. It will return the most stable version if any, otherwise the newest &quot;edge&quot; version. Examples iex&gt; K8s.Version.recommended([&quot;v1beta1&quot;, &quot;v1&quot;, &quot;v2&quot;]) &quot;v2&quot; iex&gt; K8s.Version.recommended([&quot;v1beta1&quot;, &quot;v1&quot;]) &quot;v1&quot; iex&gt; K8s.Version.recommended([&quot;v1beta2&quot;, &quot;v1beta1&quot;]) &quot;v1beta2&quot; iex&gt; K8s.Version.recommended([&quot;v1alpha1&quot;, &quot;v1alpha2&quot;, &quot;v1beta1&quot;]) &quot;v1beta1&quot;"},{"ref":"K8s.Version.html#serialize/1","title":"K8s.Version.serialize/1","type":"function","doc":"Returns only stable versions Examples iex&gt; K8s.Version.serialize(%K8s.Version{major: 1, minor: &quot;stable&quot;, patch: nil}) &quot;v1&quot; iex&gt; K8s.Version.serialize(%K8s.Version{major: 1, minor: &quot;beta&quot;, patch: 1}) &quot;v1beta1&quot; iex&gt; K8s.Version.serialize(%K8s.Version{major: 1, minor: &quot;alpha&quot;, patch: 1}) &quot;v1alpha1&quot;"},{"ref":"K8s.Version.html#sort/1","title":"K8s.Version.sort/1","type":"function","doc":"Sorts a list of K8s.Versions Examples iex&gt; raw_versions = Enum.shuffle([&quot;v1&quot;, &quot;v2beta1&quot;, &quot;v2&quot;, &quot;v1alpha1&quot;, &quot;v1alpha2&quot;]) iex&gt; versions = raw_versions |&gt; Enum.map(&amp;(K8s.Version.parse(&amp;1))) iex&gt; sorted_versions = versions |&gt; K8s.Version.sort() iex&gt; sorted_versions |&gt; Enum.map(&amp;(K8s.Version.serialize(&amp;1))) [&quot;v2&quot;, &quot;v1&quot;, &quot;v2beta1&quot;, &quot;v1alpha2&quot;, &quot;v1alpha1&quot;]"},{"ref":"K8s.Version.html#stable/1","title":"K8s.Version.stable/1","type":"function","doc":"Returns only stable versions Examples iex&gt; K8s.Version.stable([&quot;v1alpha1&quot;, &quot;v1&quot;, &quot;v2beta1&quot;]) [%K8s.Version{major: 1, minor: &quot;stable&quot;, patch: nil}]"},{"ref":"K8s.Version.html#t:t/0","title":"K8s.Version.t/0","type":"type","doc":""},{"ref":"readme.html","title":"K8s","type":"extras","doc":"K8s K8s - Kubernetes API Client for Elixir"},{"ref":"readme.html#installation","title":"K8s - Installation","type":"extras","doc":"If available in Hex, the package can be installed by adding k8s to your list of dependencies in mix.exs: def deps do [ {:k8s, &quot;~&gt; 0.2&quot;} ] end"},{"ref":"readme.html#usage","title":"K8s - Usage","type":"extras","doc":"Check out the Usage Guide for in-depth examples. Most functions are also written using doctests. K8s.Client doctests K8s.Cluster doctests K8s.Conf doctests K8s.Resource doctests K8s.Version doctests"},{"ref":"readme.html#features","title":"K8s - Features","type":"extras","doc":"A client API for humans Kubernetes resources, groups, and CRDs are autodiscovered at boot time. No swagger file to include or override. Client supports standard HTTP calls, async batches, wait on status, and watchers Supports multiple clusters Supports multiple authentication credentials Supports multiple kubernetes API Tested against kubernetes swagger specs: 1.10+ and master CRD support Kubernetes resource and version helper functions Kube config file parsing Certificate and service account based auth Pluggable auth providers Macro free; fast compile &amp; fast startup Non-features Modules for every kubernetes resource. Assume the &quot;default&quot; namespaces. Always provide a namespace when a namespace is applicable. Support for the deprecated Watch API."},{"ref":"readme.html#docs","title":"K8s - Docs","type":"extras","doc":"Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/k8s."},{"ref":"usage.html","title":"Usage","type":"extras","doc":"Usage"},{"ref":"usage.html#registering-clusters","title":"Usage - Registering Clusters","type":"extras","doc":"Clusters can be registered via config.exs or directly with K8s.Cluster.register/2. Clusters are referenced by name (:default below) when using a K8s.Client. Multiple clusters can be registered via config or at runtime. Kubernetes API resources are auto-discovered at boot time. This library is currently tested against k8s OpenAPI specs: 1.10, 1.11, 1.12, 1.13, and master. Registering Clusters at Run Time The below will register a cluster named :prod using ~/.kube.config to connect. There are many options for loading a config, this will load the user and cluster from the current-context. conf = K8s.Conf.from_file(&quot;~/.kube/config&quot;) K8s.Cluster.register(:prod, conf) Registering a cluster using the k8s&#39; ServiceAccount of the pod: conf = K8s.Conf.from_service_account() K8s.Cluster.register(:prod, conf) Registering Clusters at Compile Time (config.exs) Adding a cluster named :default using ~/.kube/config. Defaults to current-context of the kube config file. config :k8s, clusters: %{ default: %{ conf: &quot;~/.kube/config&quot; } } Using an alternate context: config :k8s, clusters: %{ default: %{ conf: &quot;~/.kube/config&quot; conf_opts: [context: &quot;other-context&quot;] } } Setting cluster and user explicitly: config :k8s, clusters: %{ default: %{ conf: &quot;~/.kube/config&quot; conf_opts: [user: &quot;some-user&quot;, cluster: &quot;prod-cluster&quot;] } } Using a pod&#39;s service account (pod.spec.serviceAccountName): A cluster name with a blank configuration will default to using the pod&#39;s service account. config :k8s, clusters: %{ default: %{} }"},{"ref":"usage.html#running-an-operation","title":"Usage - Running an operation","type":"extras","doc":"Many more client examples exist in the K8s.Client docs. Creating a Deployment from a Map resource = %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}, &quot;name&quot; =&gt; &quot;nginx-deployment&quot;, &quot;namespace&quot; =&gt; &quot;default&quot; }, &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 3, &quot;selector&quot; =&gt; %{&quot;matchLabels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}}, &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}}, &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; [ %{ &quot;image&quot; =&gt; &quot;nginx:1.7.9&quot;, &quot;name&quot; =&gt; &quot;nginx&quot;, &quot;ports&quot; =&gt; [%{&quot;containerPort&quot; =&gt; 80}] } ] } } } } operation = K8s.Client.create(resource) {:ok, response} = K8s.Client.run(operation, :dev) Creating a Deployment from a YAML file Given the YAML file priv/deployment.yaml: apiVersion: apps/v1 kind: Deployment metadata: name: &lt;%= name %&gt;-deployment namespace: &lt;%= namespace %&gt; labels: app: &lt;%= name %&gt; spec: replicas: 3 selector: matchLabels: app: &lt;%= name %&gt; template: metadata: labels: app: &lt;%= name %&gt; spec: containers: - name: &lt;%= name %&gt; image: &lt;%= image %&gt; ports: - containerPort: 80 opts = [namespace: &quot;default&quot;, name: &quot;nginx&quot;, image: &quot;nginx:nginx:1.7.9&quot;] resource = K8s.Resource.from_file!(&quot;priv/deployment.yaml&quot;, opts) operation = K8s.Client.create(resource) {:ok, deployment} = K8s.Client.run(operation, :dev) Listing Deployments In a given namespace: operation = K8s.Client.list(&quot;apps/v1&quot;, &quot;Deployment&quot;, namespace: &quot;prod&quot;) {:ok, deployments} = K8s.Client.run(operation, :dev) Across all namespaces: operation = K8s.Client.list(&quot;apps/v1&quot;, &quot;Deployment&quot;, namespace: :all) {:ok, deployments} = K8s.Client.run(operation, :dev) Note: K8s.Client.list will return a map. The list of resources will be under &quot;items&quot;. Getting a Deployment operation = K8s.Client.get(&quot;apps/v1&quot;, :deployment, [namespace: &quot;default&quot;, name: &quot;nginx-deployment&quot;]) {:ok, deployment} = K8s.Client.run(operation, :dev)"},{"ref":"usage.html#watch-operations","title":"Usage - Watch Operations","type":"extras","doc":"operation = K8s.Client.list(&quot;apps/v1&quot;, :deployment, namespace: :all) {:ok, reference} = K8s.Client.watch(operation, :dev, stream_to: self()) Kubernetes Watch API added, modified, and deleted events will be streamed as they occur."},{"ref":"usage.html#wait-on-a-resource","title":"Usage - Wait on a Resource","type":"extras","doc":"This will wait 60 seconds for the field status.succeeded to equal 1. :find and :eval also accept functions to apply to check success. operation = K8s.Client.get(&quot;batch/v1&quot;, :job, namespace: &quot;default&quot;, name: &quot;database-migrator&quot;) wait_opts = [find: [&quot;status&quot;, &quot;succeeded&quot;], eval: 1, timeout: 60] {:ok, job} = K8s.Client.wait(op, cluster_name, wait_opts)"},{"ref":"usage.html#batch-operations","title":"Usage - Batch Operations","type":"extras","doc":"Fetching two pods at once. operation1 = K8s.Client.get(&quot;v1&quot;, &quot;Pod&quot;, namespace: &quot;default&quot;, name: &quot;pod-1&quot;) operation2 = K8s.Client.get(&quot;v1&quot;, &quot;Pod&quot;, namespace: &quot;default&quot;, name: &quot;pod-2&quot;) # results will be a list of :ok and :error tuples results = K8s.Client.async([operation1, operation2], :dev) Note: all operations are fired async and their results are returned. Processing does not halt if an error occurs for one operation."},{"ref":"usage.html#custom-resource-definitions","title":"Usage - Custom Resource Definitions","type":"extras","doc":"Custom resources are discovered via the same mechanism as &quot;standard&quot; k8s resources and can be worked with as such: Listing the Greetings from the hello operator. operation = K8s.Client.list(&quot;hello-operator.example.com/v1&quot;, :greeting, [namespace: &quot;default&quot;]) {:ok, greeting} = K8s.Client.run(operation, :dev)"},{"ref":"usage.html#multiple-clusters","title":"Usage - Multiple Clusters","type":"extras","doc":"Copying a workloads between two clusters: Register a staging cluster: staging_conf = K8s.Conf.from_file(&quot;~/.kube/config&quot;) staging = K8s.Cluster.register(:staging, staging_conf) Register a prod cluster: prod_conf = K8s.Conf.from_service_account() # or from_file/2 prod = K8s.Cluster.register(:prod, staging_conf) Get a list of all deployments in the default prod namespace: operation = K8s.Client.list(&quot;apps/v1&quot;, :deployment, namespace: &quot;default&quot;) {:ok, deployments} = K8s.Client.run(operation, :prod) Map the deployments to operations and async create on staging: deployments |&gt; Enum.map(fn(deployment) -&gt; K8s.Client.create(deployment) end) |&gt; K8s.Client.async(:staging)"},{"ref":"usage.html#adding-authorization-providers","title":"Usage - Adding Authorization Providers","type":"extras","doc":"config :k8s, auth_providers: [My.Custom.Provider] Providers are checked in order, the first to return an authorization struct wins. Custom providers are processed before default providers. See Certificate and Token for protocol and behavior implementations."}]